#ifndef _COMPAT_GRANT_TABLE_H
#define _COMPAT_GRANT_TABLE_H
#include <xen/compat.h>
#include <public/grant_table.h>
#pragma pack(4)
struct compat_grant_entry {

    uint16_t flags;

    domid_compat_t domid;

    uint32_t frame;
};
typedef struct grant_entry grant_entry_compat_t;
typedef uint32_t grant_ref_compat_t;

typedef uint32_t grant_handle_compat_t;
struct compat_gnttab_map_grant_ref {

    uint64_t host_addr;
    uint32_t flags;
    grant_ref_compat_t ref;
    domid_compat_t dom;

    int16_t status;
    grant_handle_compat_t handle;
    uint64_t dev_bus_addr;
};
typedef struct gnttab_map_grant_ref gnttab_map_grant_ref_compat_t;
DEFINE_COMPAT_HANDLE(gnttab_map_grant_ref_compat_t);
struct compat_gnttab_unmap_grant_ref {

    uint64_t host_addr;
    uint64_t dev_bus_addr;
    grant_handle_compat_t handle;

    int16_t status;
};
typedef struct gnttab_unmap_grant_ref gnttab_unmap_grant_ref_compat_t;
DEFINE_COMPAT_HANDLE(gnttab_unmap_grant_ref_compat_t);
struct compat_gnttab_setup_table {

    domid_compat_t dom;
    uint32_t nr_frames;

    int16_t status;
    COMPAT_HANDLE(ulong) frame_list;
};
typedef struct compat_gnttab_setup_table gnttab_setup_table_compat_t;
DEFINE_COMPAT_HANDLE(gnttab_setup_table_compat_t);

struct compat_gnttab_dump_table {

    domid_compat_t dom;

    int16_t status;
};
typedef struct gnttab_dump_table gnttab_dump_table_compat_t;
DEFINE_COMPAT_HANDLE(gnttab_dump_table_compat_t);
struct compat_gnttab_transfer {

    compat_pfn_t mfn;
    domid_compat_t domid;
    grant_ref_compat_t ref;

    int16_t status;
};
typedef struct compat_gnttab_transfer gnttab_transfer_compat_t;
DEFINE_COMPAT_HANDLE(gnttab_transfer_compat_t);
typedef struct compat_gnttab_copy {

    struct {
        union {
            grant_ref_compat_t ref;
            compat_pfn_t gmfn;
        } u;
        domid_compat_t domid;
        uint16_t offset;
    } source, dest;
    uint16_t len;
    uint16_t flags;

    int16_t status;
} gnttab_copy_compat_t;
DEFINE_COMPAT_HANDLE(gnttab_copy_compat_t);
struct compat_gnttab_query_size {

    domid_compat_t dom;

    uint32_t nr_frames;
    uint32_t max_nr_frames;
    int16_t status;
};
typedef struct compat_gnttab_query_size gnttab_query_size_compat_t;
DEFINE_COMPAT_HANDLE(gnttab_query_size_compat_t);
#pragma pack()
#endif /* _COMPAT_GRANT_TABLE_H */
