#ifndef _COMPAT_PHYSDEV_H
#define _COMPAT_PHYSDEV_H
#include <xen/compat.h>
#include <public/physdev.h>
#pragma pack(4)
struct compat_physdev_eoi {

    uint32_t irq;
};
typedef struct compat_physdev_eoi physdev_eoi_compat_t;
DEFINE_COMPAT_HANDLE(physdev_eoi_compat_t);

struct compat_physdev_irq_status_query {

    uint32_t irq;

    uint32_t flags;
};
typedef struct compat_physdev_irq_status_query physdev_irq_status_query_compat_t;
DEFINE_COMPAT_HANDLE(physdev_irq_status_query_compat_t);
struct compat_physdev_set_iopl {

    uint32_t iopl;
};
typedef struct compat_physdev_set_iopl physdev_set_iopl_compat_t;
DEFINE_COMPAT_HANDLE(physdev_set_iopl_compat_t);

struct compat_physdev_set_iobitmap {

    COMPAT_HANDLE(uint8_t) bitmap;
    uint32_t nr_ports;
};
typedef struct compat_physdev_set_iobitmap physdev_set_iobitmap_compat_t;
DEFINE_COMPAT_HANDLE(physdev_set_iobitmap_compat_t);

struct compat_physdev_apic {

    unsigned int apic_physbase;
    uint32_t reg;

    uint32_t value;
};
typedef struct compat_physdev_apic physdev_apic_compat_t;
DEFINE_COMPAT_HANDLE(physdev_apic_compat_t);

struct compat_physdev_irq {

    uint32_t irq;

    uint32_t vector;
};
typedef struct compat_physdev_irq physdev_irq_compat_t;
DEFINE_COMPAT_HANDLE(physdev_irq_compat_t);

struct compat_physdev_op {
    uint32_t cmd;
    union {
        struct compat_physdev_irq_status_query irq_status_query;
        struct compat_physdev_set_iopl set_iopl;
        struct compat_physdev_set_iobitmap set_iobitmap;
        struct compat_physdev_apic apic_op;
        struct compat_physdev_irq irq_op;
    } u;
};
typedef struct compat_physdev_op physdev_op_compat_t;
DEFINE_COMPAT_HANDLE(physdev_op_compat_t);
#pragma pack()
#endif /* _COMPAT_PHYSDEV_H */
